// ChildFrm.cpp : implementation of the CChildFrame class
//

#include "stdafx.h"
#include "bbstuff.h"
#include "bibobApp.h"
#include "ChildFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

enum {
	FIRST_AUTO_DELAY = 50, 
	MAX_AUTO_DELAY =  799, 
	MIN_AUTO_DELAY =    1, 
	BUTTON_RELEASE_DELAY = 320};

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	ON_WM_CREATE()
	ON_WM_TIMER()
	ON_COMMAND(IDC_ENTER_BB_COMBO, OnEnterBbCombo)
	ON_COMMAND(IDC_CURRENT_BOARD, OnCurrentBoard)
	ON_COMMAND(IDC_CLEAR_COMBO, OnClearCombo)
	ON_COMMAND(IDC_DEFAULT_CONTENT, OnDefaultContent)
	ON_COMMAND(IDC_IMPLICIT_CHOOSE, OnImplicitChoose)
	ON_UPDATE_COMMAND_UI(IDC_IMPLICIT_CHOOSE, OnUpdateImplicitChoose)
	ON_UPDATE_COMMAND_UI(IDC_CLEAR_COMBO, OnUpdateClearCombo)
	ON_UPDATE_COMMAND_UI(IDC_DEFAULT_CONTENT, OnUpdateDefaultContent)
	ON_COMMAND(IDC_ADD, OnAdd)
	ON_COMMAND(IDC_SUB, OnSub)
	ON_COMMAND(IDC_MUL, OnMul)
	ON_COMMAND(IDC_MULH, OnMulh)
	ON_COMMAND(IDC_DIV, OnDiv)
	ON_COMMAND(IDC_MODULUS, OnModulus)
	ON_COMMAND(IDC_AND, OnAnd)
	ON_COMMAND(IDC_AND_NOT, OnAndNot)
	ON_COMMAND(IDC_OR, OnOr)
	ON_COMMAND(IDC_XOR, OnXor)
	ON_COMMAND(IDC_ASSIGN, OnAssign)
	ON_COMMAND(IDC_ENTER_FEN, OnEnterFen)
	ON_COMMAND(IDC_CALC_FLOAT, OnCalcFloat)
	ON_COMMAND(IDC_CALC_INT, OnCalcInt)
	ON_UPDATE_COMMAND_UI(IDC_CALC_FLOAT, OnUpdateCalcFloat)
	ON_UPDATE_COMMAND_UI(IDC_CALC_INT, OnUpdateCalcInt)
	ON_UPDATE_COMMAND_UI(IDC_ADD, OnUpdateAdd)
	ON_UPDATE_COMMAND_UI(IDC_SUB, OnUpdateSub)
	ON_UPDATE_COMMAND_UI(IDC_MUL, OnUpdateMul)
	ON_UPDATE_COMMAND_UI(IDC_MULH, OnUpdateMulh)
	ON_UPDATE_COMMAND_UI(IDC_DIV, OnUpdateDiv)
	ON_UPDATE_COMMAND_UI(IDC_MODULUS, OnUpdateModulus)
	ON_UPDATE_COMMAND_UI(IDC_AND, OnUpdateAnd)
	ON_UPDATE_COMMAND_UI(IDC_AND_NOT, OnUpdateAndNot)
	ON_UPDATE_COMMAND_UI(IDC_OR, OnUpdateOr)
	ON_UPDATE_COMMAND_UI(IDC_XOR, OnUpdateXor)
	ON_UPDATE_COMMAND_UI(IDC_ASSIGN, OnUpdateAssign)
	ON_UPDATE_COMMAND_UI(IDC_DECREMENT, OnUpdateDecrement)
	ON_UPDATE_COMMAND_UI(IDC_INCREMENT, OnUpdateIncrement)
	ON_COMMAND(IDC_CALC_I32, OnCalcI32)
	ON_COMMAND(IDC_CALC_I16, OnCalcI16)
	ON_COMMAND(IDC_CALC_I8, OnCalcI8)
	ON_UPDATE_COMMAND_UI(IDC_CALC_I32, OnUpdateCalcI32)
	ON_UPDATE_COMMAND_UI(IDC_CALC_I16, OnUpdateCalcI16)
	ON_UPDATE_COMMAND_UI(IDC_CALC_I8, OnUpdateCalcI8)
	ON_UPDATE_COMMAND_UI(IDC_STOP_AUTO, OnUpdateAutoStop)
	ON_COMMAND(IDC_AUTO_START, OnAutoStart)
	ON_UPDATE_COMMAND_UI(IDC_AUTO_START, OnUpdateAutoStart)
	ON_NOTIFY(TBN_DROPDOWN, AFX_IDW_TOOLBAR, OnToolbarDropDown)
END_MESSAGE_MAP()

CChildFrame::CChildFrame()
{
	m_Timer = NULL;
	m_BitBoard = 0; 
	m_Auto  = false;
	m_AutoDelay = MAX_AUTO_DELAY/2;
	m_calcmode = I64;
	m_HasSecondOperand = false;
	m_AssignAfterSelendOk = false;
	m_FixedOperand = true;
	m_first = true;
	m_EditUsed = false;
	m_hasFenCombo = false;

	m_command = IDC_DUMMY_FILL;
	m_prevCommand = IDC_DUMMY_FILL;
}

CChildFrame::~CChildFrame()
{
}

enum {
	COMBO_HEIGHT = 220,
	COMBO_WIDTH  = 280,
	FEN_COMBO_HEIGHT = 320,
	FEN_COMBO_WIDTH =  480
};

// CChildFrame diagnostics
#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

// CChildFrame message handlers
int CChildFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	CRect comborect(210, 0, 210+COMBO_HEIGHT, COMBO_WIDTH);
	CRect rightrect;
	int idx;

	if (CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_ToolBinary.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_ToolBinary.LoadToolBar(IDR_OPS))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;
	}
	if (!m_ToolFen.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_LEFT
		| CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_ToolFen.LoadToolBar(IDR_PASTE_FEN))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;
	}

	
	idx = m_ToolBinary.CommandToIndex( IDC_COMBO_SECOND_OPERAND);
	if ( idx >= 0 ) {
		m_ToolBinary.GetItemRect(idx, comborect);
		//comborect.left -= 1;
		comborect.right  = comborect.left + COMBO_WIDTH;
		comborect.bottom = comborect.top  + COMBO_HEIGHT;
	}
	idx = m_ToolBinary.CommandToIndex( IDC_COMBO_RIGHTDUMMY);
	if ( idx >= 0 ) {
		m_ToolBinary.GetItemRect(idx, rightrect);
		comborect.right = rightrect.right; // + 1;
	}
	if (!m_Combo.Create (WS_CHILD|WS_VISIBLE|WS_VSCROLL|CBS_DROPDOWN, 
							comborect, &m_ToolBinary, IDC_COMBO_SECOND_OPERAND))
	{
		TRACE0("Failed to create combobox\n");
		return -1;
	}

	m_Combo.SetFont(theApp.getFont());
	m_Combo.InitStorage(256, 32);
	m_Combo.SetDroppedWidth(COMBO_WIDTH);
	m_Combo.SetExtendedUI(true);

	enumerateBitBoards(); 
	//m_Combo.SetCurSel(1);


	idx = m_ToolFen.CommandToIndex( IDC_COMBO_FEN );
	if ( idx >= 0 ) {
		m_ToolFen.GetItemRect(idx, comborect);
		comborect.bottom = comborect.top + FEN_COMBO_HEIGHT;
		m_FenCombo.Create (WS_CHILD|WS_VISIBLE|WS_VSCROLL|CBS_DROPDOWNLIST, 
							comborect, &m_ToolFen, IDC_COMBO_FEN);
		m_FenCombo.InitStorage(64, 64);
		m_FenCombo.SetDroppedWidth(FEN_COMBO_WIDTH);
		m_FenCombo.SetFont(theApp.getFont());
		m_FenCombo.SetExtendedUI(true);
		m_hasFenCombo = true;
		m_FenCombo.AddString(_T("rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w - - KQkq"));
		m_FenCombo.AddString(_T("Clear local Fen"));
	}

	idx = m_ToolBinary.CommandToIndex( IDC_SLIDER );
	if ( idx >= 0 ) {
		m_ToolBinary.GetItemRect(idx, comborect);
		comborect.left  += 12;
		comborect.right += 80;
		comborect.bottom -= 2; //10;
		m_Slider.Create(WS_CHILD|WS_VISIBLE|WS_THICKFRAME|TBS_HORZ|TBS_AUTOTICKS,
						comborect, &m_ToolBinary, IDC_SLIDER);
		m_Slider.SetRange( 1, MAX_AUTO_DELAY);
		m_Slider.SetPos(MAX_AUTO_DELAY+1-m_AutoDelay);
		m_Slider.SetTicFreq(100);
	}

	m_ToolBinary.SendMessage(TB_SETEXTENDEDSTYLE, 0, TBSTYLE_EX_DRAWDDARROWS);
	m_ToolFen.SendMessage(TB_SETEXTENDEDSTYLE, 0, TBSTYLE_EX_DRAWDDARROWS);

	int iButton = m_ToolBinary.SendMessage(TB_COMMANDTOINDEX,IDC_ASSIGN);
	DWORD dwStyle = m_ToolBinary.GetButtonStyle(iButton);
	dwStyle |= TBSTYLE_DROPDOWN;
	m_ToolBinary.SetButtonStyle(iButton, dwStyle);

	return 0;
}

void CChildFrame::OnToolbarDropDown(NMTOOLBAR* pnmtb, LRESULT *plr)
{
	switch ( pnmtb->iItem )
	{
	case IDC_ASSIGN:
		PostMessage(WM_COMMAND, IDC_CURRENT_BOARD, 0);
		break;
	case IDC_SETALL:
		theApp.m_pMainWnd->PostMessage(WM_COMMAND, IDC_CHOOSE_NEMU);
		break;
	case IDC_MINUS:
		PostMessage(WM_COMMAND, pnmtb->iItem, 0);
		break;

	case IDC_INCREMENT:
	case IDC_DECREMENT:
	case IDC_SHR:
	case IDC_SHL:
	case IDC_UP:
	case IDC_DOWN:
		startAutomode(pnmtb->iItem);
		break;
	default:
		bool fixed = m_FixedOperand;
		m_FixedOperand = false;
		SendMessage(WM_COMMAND, pnmtb->iItem, 0);
		m_FixedOperand = fixed;
		break;
	}
}


void CChildFrame::enumerateBitBoards() {
	CString curselStr("0x0101010101010101 - A-File");
	int idx = m_Combo.GetCurSel();
	if ( idx >= 0 ) 
		m_Combo.GetLBText(idx, curselStr);
	
	if ( m_first ) {
		// some constant strings only once
		// items starting with underscores are commensts
		m_first = false;
		m_Combo.AddString(_T("___Document_Bitboards_History"));
		//m_Combo.AddString(_T("0x0000000000000000"));
		m_Combo.AddString(_T("__Files & Ranks__"));
		m_Combo.AddString(_T("0x0101010101010101"));
		m_Combo.AddString(_T("0x0202020202020202"));
		m_Combo.AddString(_T("0x0404040404040404"));
		m_Combo.AddString(_T("0x0808080808080808"));
		m_Combo.AddString(_T("0x1010101010101010"));
		m_Combo.AddString(_T("0x2020202020202020"));
		m_Combo.AddString(_T("0x4040404040404040"));
		m_Combo.AddString(_T("0x8080808080808080"));
		m_Combo.AddString(_T("0x00000000000000FF"));
		m_Combo.AddString(_T("0x000000000000FF00"));
		m_Combo.AddString(_T("0x0000000000FF0000"));
		m_Combo.AddString(_T("0x00000000FF000000"));
		m_Combo.AddString(_T("0x000000FF00000000"));
		m_Combo.AddString(_T("0x0000FF0000000000"));
		m_Combo.AddString(_T("0x00FF000000000000"));
		m_Combo.AddString(_T("0xFF00000000000000"));
		m_Combo.AddString(_T("____Diagonals_____"));
		m_Combo.AddString(_T("0x8040201008040201"));
		m_Combo.AddString(_T("0x0102040810204080"));
		m_Combo.AddString(_T("______Areas_______"));
		m_Combo.AddString(_T("0x0000001818000000"));
		m_Combo.AddString(_T("0x00003C3C3C3C0000"));
		m_Combo.AddString(_T("0xFF818181818181FF"));
		m_Combo.AddString(_T("0xFFFFC3C3C3C3FFFF"));
		m_Combo.AddString(_T("0x55AA55AA55AA55AA"));
		m_Combo.AddString(_T("0xAA55AA55AA55AA55"));
		m_Combo.AddString(_T("0x00000000FFFFFFFF"));
		m_Combo.AddString(_T("0xFFFFFFFF00000000"));
		m_Combo.AddString(_T("0xF0F0F0F0F0F0F0F0"));
		m_Combo.AddString(_T("0x0F0F0F0F0F0F0F0F"));
		m_Combo.AddString(_T("__Entered_Numbers_"));
	}
	theApp.enumerateBBDocs(m_Combo); 
	idx = m_Combo.FindStringExact(-1, curselStr);
	if ( idx >= 0 )
		m_Combo.SetCurSel(idx);
}

void CChildFrame::insert2combo(const CString& str) {
	int kind;
	m_CurselStr = str;
	m_BitBoard = hexdecfenBB(str, -1, DBL, kind);
	m_HasSecondOperand = true;
	int idx =  m_Combo.FindStringExact(-1, str);
	if ( idx < 0 ) {
		if ( kind == IS_DBL )
			idx = m_Combo.AddString(str);
		else
			idx = m_Combo.InsertString(1, str);
	}
	m_Combo.SetCurSel(idx);
	m_Combo.SetWindowText(str);
}

bool CChildFrame::isFloatIntSensible() const {
	return (
		(m_command == IDC_ADD1) +
		(m_command == IDC_SUB1) +
		(m_command == IDC_MUL1) +
		(m_command == IDC_DIV1) ) != 0;
}

void CChildFrame::insert2FenCombo(const CString &s)
{
	if ( m_hasFenCombo )
		if ( m_FenCombo.FindStringExact(-1, s) < 0 )
			m_FenCombo.InsertString(0, s);
}


BOOL CChildFrame::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	static char sAllowedChars[] = _T("0123456789abcdefABCDEFhHxX.");

	CString tmp;
	DWORD dwSel;
	int idx, sel, kind;

	if ( LOWORD(wParam) == IDC_COMBO_FEN ) {
		if ( HIWORD(wParam) == CBN_SELENDOK ) {
			idx = m_FenCombo.GetCurSel();
			if ( idx < 0 ) 
				idx = 0;
			m_FenCombo.GetLBText(idx, m_CurselFenStr);
			PostMessage(WM_COMMAND, IDC_FEN_CHOOSED, 0L);
			SetFocus(); // kills focus of combo
		}
	}

	if ( LOWORD(wParam) == IDC_COMBO_SECOND_OPERAND ) {
		//TRACE("Notity %d\n", HIWORD(wParam));
		switch (HIWORD(wParam))
		{
		case CBN_SELCHANGE:
			m_EditUsed = false;
			break;
		case CBN_SETFOCUS:
			m_AssignAfterSelendOk = false;
			m_EditUsed = false;
			enumerateBitBoards(); 
			idx = m_Combo.GetCurSel();
			if ( idx >= 0 ) {
				m_Combo.GetLBText(idx, m_CurselStr);
				m_Combo.SetTopIndex(idx);
			} else {
				m_Combo.GetWindowText(m_CurselStr);
			}
			break;
		case CBN_KILLFOCUS:
			m_command = IDC_DUMMY_FILL;
			m_AssignAfterSelendOk = false;
			break;
		case CBN_EDITUPDATE:
			m_EditUsed = true;
			if ( !isComboDropped () )
				m_Combo.ShowDropDown();
			m_Combo.GetWindowText(tmp);
			if(tmp.GetLength() == 0 ) 
				break; // no new character
			dwSel = m_Combo.GetEditSel();
			sel = LOWORD(dwSel);
			if( sel == 0 || sel != HIWORD( dwSel ) ) 
				break;// no new character
			if ( strchr(sAllowedChars, tmp.GetAt(sel-1)) == NULL ) {
				// invalid character
				tmp = tmp.Left(sel-1) + tmp.Mid(sel);
				m_Combo.SetWindowText(tmp);
				m_Combo.SetEditSel(sel, sel);
				MessageBeep(-1);
			}
			break;

		case CBN_SELENDOK:
			if ( m_EditUsed ) {
				m_Combo.GetWindowText(m_CurselStr);
				idx = m_Combo.FindStringExact(-1, m_CurselStr);
				if ( idx < 0 )
					idx = m_Combo.AddString(m_CurselStr);
				m_Combo.SetCurSel(idx);
			} else {
				idx = m_Combo.GetCurSel();
				if ( idx < 0 ) 
					idx = 0;
				m_Combo.GetLBText(idx, m_CurselStr);
			}
			if ( m_CurselStr.GetAt(0) == '_') {  // don't confirm comment lines
				PostMessage(WM_SETFOCUS, 0, 0L);
				m_HasSecondOperand = false;
				break;
			}
			m_BitBoard = hexdecfenBB(m_CurselStr, -1, m_calcmode, kind);
			m_HasSecondOperand = true;
			if ( m_AssignAfterSelendOk ) {
				m_AssignAfterSelendOk = false;
				PostMessage(WM_COMMAND, m_command, 0L);
			}
			PostMessage(WM_SETFOCUS, 0, 0L);
			break;
		case CBN_SELENDCANCEL:
			PostMessage(WM_SETFOCUS, 0, 0L); //SetFocus() makes problems
			break;
		}
	}
	return CMDIChildWnd::OnCommand(wParam, lParam);
}

void CChildFrame::postChar2Combo(UINT nChar) {
	m_Combo.PostMessage(WM_CHAR, nChar, 0);
}

void CChildFrame::DropDown() {
	m_Combo.SetFocus();
	m_Combo.ShowDropDown();
}
	
void CChildFrame::DropDownWithOp(DWORD cmd) {
	DropDown(); 
	m_AssignAfterSelendOk = true;
	m_command = cmd;
}

void CChildFrame::operate(DWORD cmd) {
	if ( !m_FixedOperand || !m_HasSecondOperand ) {
		DropDownWithOp(cmd);
	} else {
		PostMessage(WM_COMMAND, cmd, 0L);
		m_command = cmd;
		if ( m_Timer ) 
			KillTimer(m_Timer);
		m_Timer = SetTimer(cmd, BUTTON_RELEASE_DELAY, NULL);
	}
}

void CChildFrame::startAutomode(DWORD cmd) {
	if ( m_Timer ) 
		KillTimer(m_Timer);
	m_Auto = true;
	m_Timer = SetTimer(m_command = cmd, FIRST_AUTO_DELAY, NULL);
}

void CChildFrame::stopAuto() {
	if (m_Timer) 
		KillTimer(m_Timer);
	m_Timer = NULL;
	m_Auto  = false;
	m_prevCommand = m_command;
	m_command = IDC_DUMMY_FILL;
}

void CChildFrame::OnTimer(UINT nIDEvent) 
{
	if ( nIDEvent == m_command )
	{
		if ( m_Auto ) {
			KillTimer(m_Timer);
			PostMessage(WM_COMMAND, m_command, 0);
			int delay = (m_AutoDelay*m_AutoDelay)/MAX_AUTO_DELAY;
			m_Timer = SetTimer(m_command, delay, NULL);
		} else {
			KillTimer(m_Timer);
			m_Timer = NULL;
			m_prevCommand = m_command;
			m_command = IDC_DUMMY_FILL;
		}
	}
	CMDIChildWnd::OnTimer(nIDEvent);
}

void CChildFrame::OnEnterBbCombo() {DropDown();}
void CChildFrame::OnCurrentBoard() {DropDownWithOp(IDC_ASSIGN1);}

void CChildFrame::OnEnterFen() 
{
	if ( m_hasFenCombo ) {
		m_FenCombo.SetFocus();
		m_FenCombo.ShowDropDown();
	}
}

void CChildFrame::OnClearCombo() {
	m_Combo.ResetContent();
	m_Combo.AddString("___Document-Bitboards - History");
	m_Combo.AddString("_Entered Numbers_");
}

void CChildFrame::OnDefaultContent() {
	m_Combo.ResetContent();
	m_first = true;
}

void CChildFrame::OnImplicitChoose() {m_FixedOperand = !m_FixedOperand;}

void CChildFrame::OnUpdateClearCombo(CCmdUI* pc) {pc->Enable(!isComboDropped());}
void CChildFrame::OnUpdateDefaultContent(CCmdUI* pc) {pc->Enable(!isComboDropped());}
void CChildFrame::OnUpdateImplicitChoose(CCmdUI* pc) {pc->SetCheck(m_FixedOperand);}

void CChildFrame::OnAdd()	{operate(IDC_ADD1);}
void CChildFrame::OnSub()	{operate(IDC_SUB1);}
void CChildFrame::OnMul()	{operate(IDC_MUL1);}
void CChildFrame::OnMulh()	{operate(IDC_MULH1);}
void CChildFrame::OnDiv()	{operate(IDC_DIV1);}
void CChildFrame::OnAnd()	{operate(IDC_AND1);}
void CChildFrame::OnAndNot(){operate(IDC_AND_NOT1);}
void CChildFrame::OnOr()	{operate(IDC_OR1);}
void CChildFrame::OnXor()	{operate(IDC_XOR1);}

void CChildFrame::OnModulus() {operate(IDC_MODULUS1);}

void CChildFrame::OnUpdateAdd (CCmdUI* pc)  {pc->SetCheck(m_command == IDC_ADD1);}
void CChildFrame::OnUpdateSub (CCmdUI* pc)  {pc->SetCheck(m_command == IDC_SUB1);}
void CChildFrame::OnUpdateMul (CCmdUI* pc)  {pc->SetCheck(m_command == IDC_MUL1);}
void CChildFrame::OnUpdateMulh(CCmdUI* pc)  {pc->SetCheck(m_command == IDC_MULH1);}

void CChildFrame::OnUpdateDiv (CCmdUI* pc) {
	pc->Enable(m_calcmode <= I64);
	pc->SetCheck(m_command == IDC_DIV1);
}

void CChildFrame::OnUpdateModulus(CCmdUI* pc) 
{
	pc->Enable(m_calcmode <= I64);
	pc->SetCheck(m_command == IDC_DIV1);
}

void CChildFrame::OnUpdateAnd (CCmdUI* pc)  {pc->SetCheck(m_command == IDC_AND1 );}
void CChildFrame::OnUpdateAndNot(CCmdUI* pc){pc->SetCheck(m_command == IDC_AND_NOT1);}
void CChildFrame::OnUpdateOr  (CCmdUI* pc)  {pc->SetCheck(m_command == IDC_OR1  );}
void CChildFrame::OnUpdateXor (CCmdUI* pc)  {pc->SetCheck(m_command == IDC_XOR1 );}

void CChildFrame::OnUpdateAssign(CCmdUI* pc) {pc->SetCheck(m_command == IDC_ASSIGN1);}
void CChildFrame::OnUpdateDecrement(CCmdUI* pc) {pc->SetCheck(m_command == IDC_DECREMENT );}
void CChildFrame::OnUpdateIncrement(CCmdUI* pc) {pc->SetCheck(m_command == IDC_INCREMENT );}


void CChildFrame::OnAssign() 
{
	if ( hasSecondOperand() ) {
		PostMessage(WM_COMMAND, IDC_ASSIGN1, 0L);
		m_command = IDC_ASSIGN1;
		if ( m_Timer ) 
			KillTimer(m_Timer);
		m_Timer = SetTimer(IDC_ASSIGN1, BUTTON_RELEASE_DELAY, NULL);
	} else {
		DropDownWithOp(IDC_ASSIGN1);
	}
}


void CChildFrame::OnCalcFloat() {m_calcmode = DBL; Invalidate();}
void CChildFrame::OnCalcInt()  {m_calcmode = I64; Invalidate();}
void CChildFrame::OnCalcI32() {m_calcmode = I32; Invalidate();}
void CChildFrame::OnCalcI16() {m_calcmode = I16; Invalidate();}
void CChildFrame::OnCalcI8() {m_calcmode = I8; Invalidate();}


void CChildFrame::OnUpdateCalcFloat(CCmdUI* pc)
{
	pc->SetCheck(m_calcmode == DBL);
}

void CChildFrame::OnUpdateCalcInt(CCmdUI* pc)
{
	pc->SetCheck(m_calcmode == I64);
}

void CChildFrame::OnUpdateCalcI32(CCmdUI* pc)
{
	pc->SetCheck(m_calcmode == I32);
}

void CChildFrame::OnUpdateCalcI16(CCmdUI* pc)
{
	pc->SetCheck(m_calcmode == I16);
}

void CChildFrame::OnUpdateCalcI8(CCmdUI* pc)
{
	pc->SetCheck(m_calcmode == I8);
}

void CChildFrame::OnUpdateAutoStop(CCmdUI* pc) 
{
	pc->Enable(m_Auto);
}

void CChildFrame::OnAutoStart() 
{
	startAutomode(m_prevCommand);
}

void CChildFrame::OnUpdateAutoStart(CCmdUI* pc) 
{
	pc->Enable(!m_Auto);
}

BOOL CChildFrame::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	if ( wParam == IDC_SLIDER )
	{
		m_AutoDelay = MAX_AUTO_DELAY+1 - m_Slider.GetPos();
	}
	return CMDIChildWnd::OnNotify(wParam, lParam, pResult);
}
