#if !defined(CHILDFRM_H_INCLUDED_)
#define CHILDFRM_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CChildFrame : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CChildFrame)
public:
	CChildFrame();
	virtual ~CChildFrame();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	bool hasSecondOperand() const {return m_HasSecondOperand;}
	u64  getSecondOperand() const {return m_BitBoard;}
	bool isComboDropped() {return m_Combo.GetDroppedState() != 0;}
	const CString& getChoosedFen() {return m_CurselFenStr;}
	int  calcMode() const {return m_calcmode;}

	void postChar2Combo(UINT nChar);
	void insert2combo(const CString& hex);
	void insert2FenCombo(const CString &s);
	void startAutomode(DWORD cmd);
	void stopAuto();

protected:
	void enumerateBitBoards();
	void DropDown();
	void DropDownWithOp(DWORD cmd);
	void operate(DWORD cmd);
	bool isFloatIntSensible() const;

	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);

protected:
	CToolBar    m_ToolBinary;
	CToolBar    m_ToolFen;
	CComboBox	m_Combo;
	CComboBox	m_FenCombo;
	CSliderCtrl	m_Slider;
	CString		m_CurselStr;
	CString		m_CurselFenStr;
	UINT_PTR	m_Timer;
	int			m_calcmode;
	int			m_AutoDelay;
	u64			m_BitBoard; 
	DWORD		m_command;
	DWORD		m_prevCommand;
	bool		m_HasSecondOperand;
	bool		m_AssignAfterSelendOk;
	bool		m_Auto;

	bool		m_FixedOperand;
	bool		m_first;
	bool		m_EditUsed;
	bool		m_hasFenCombo;

// message map functions
protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnEnterBbCombo();
	afx_msg void OnCurrentBoard();
	afx_msg void OnClearCombo();
	afx_msg void OnDefaultContent();
	afx_msg void OnImplicitChoose();
	afx_msg void OnUpdateImplicitChoose(CCmdUI* pCmdUI);
	afx_msg void OnUpdateClearCombo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDefaultContent(CCmdUI* pCmdUI);
	afx_msg void OnAdd();
	afx_msg void OnSub();
	afx_msg void OnMul();
	afx_msg void OnMulh();
	afx_msg void OnDiv();
	afx_msg void OnModulus();
	afx_msg void OnAnd();
	afx_msg void OnAndNot();
	afx_msg void OnOr();
	afx_msg void OnXor();
	afx_msg void OnAssign();
	afx_msg void OnEnterFen();
	afx_msg void OnCalcFloat();
	afx_msg void OnCalcInt();
	afx_msg void OnUpdateCalcFloat(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCalcInt(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAdd(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSub(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMul(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMulh(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDiv(CCmdUI* pCmdUI);
	afx_msg void OnUpdateModulus(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAnd(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAndNot(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOr(CCmdUI* pCmdUI);
	afx_msg void OnUpdateXor(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAssign(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDecrement(CCmdUI* pCmdUI);
	afx_msg void OnUpdateIncrement(CCmdUI* pCmdUI);
	afx_msg void OnCalcI32();
	afx_msg void OnCalcI16();
	afx_msg void OnCalcI8();
	afx_msg void OnUpdateCalcI32(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCalcI16(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCalcI8(CCmdUI* pCmdUI);
	afx_msg void OnUpdateAutoStop(CCmdUI* pCmdUI);
	afx_msg void OnAutoStart();
	afx_msg void OnUpdateAutoStart(CCmdUI* pCmdUI);
	afx_msg void OnToolbarDropDown(NMTOOLBAR* pnmh, LRESULT* plRes);
	DECLARE_MESSAGE_MAP()
};

#endif // !defined(CHILDFRM_H_INCLUDED_)
