#include "stdafx.h"
#include "bibobApp.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_COMMAND(IDC_CHOOSE_NEMU, OnChooseConstant)
	ON_COMMAND(ID_VIEW_LERF, OnLERF)
	ON_COMMAND(ID_VIEW_BERF, OnBERF)
	ON_COMMAND(ID_VIEW_LEFR, OnLEFR)
	ON_COMMAND(ID_VIEW_BEFR, OnBEFR)
	ON_COMMAND(ID_VIEW_LERBEF, OnLERBEF)
	ON_COMMAND(ID_VIEW_BERLEF, OnBERLEF)
	ON_COMMAND(ID_VIEW_LEFBER, OnLEFBER)
	ON_COMMAND(ID_VIEW_BEFLER, OnBEFLER)
	ON_UPDATE_COMMAND_UI(ID_VIEW_LERF, OnUpdateLERF)
	ON_UPDATE_COMMAND_UI(ID_VIEW_BERF, OnUpdateBERF)
	ON_UPDATE_COMMAND_UI(ID_VIEW_LEFR, OnUpdateLEFR)
	ON_UPDATE_COMMAND_UI(ID_VIEW_BEFR, OnUpdateBEFR)
	ON_UPDATE_COMMAND_UI(ID_VIEW_LERBEF, OnUpdateLERBEF)
	ON_UPDATE_COMMAND_UI(ID_VIEW_BERLEF, OnUpdateBERLEF)
	ON_UPDATE_COMMAND_UI(ID_VIEW_LEFBER, OnUpdateLEFBER)
	ON_UPDATE_COMMAND_UI(ID_VIEW_BEFLER, OnUpdateBEFLER)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

CMainFrame::CMainFrame()
{
	m_mapping_mode = e_lerf;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndToolBinary.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBinary.LoadToolBar(IDR_BINARY))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}


	if (!m_wndToolUnary.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolUnary.LoadToolBar(IDR_UNARY))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.SendMessage(TB_SETEXTENDEDSTYLE, 0, TBSTYLE_EX_DRAWDDARROWS);
	m_wndToolBinary.SendMessage(TB_SETEXTENDEDSTYLE, 0, TBSTYLE_EX_DRAWDDARROWS);
	m_wndToolUnary.SendMessage(TB_SETEXTENDEDSTYLE, 0, TBSTYLE_EX_DRAWDDARROWS);

	m_wndToolBinary.SetWindowText(_T("Binary Operands"));
	m_wndToolUnary.SetWindowText(_T("Unary Operands"));
	m_wndToolBar.SetWindowText(_T("Toolbar"));

	// binary operands
	makeDropdown(IDC_ASSIGN);
	makeDropdown(IDC_ADD);
	makeDropdown(IDC_SUB);
	makeDropdown(IDC_MUL);
	makeDropdown(IDC_DIV);
	makeDropdown(IDC_MODULUS);
	makeDropdown(IDC_MULH);
	makeDropdown(IDC_AND);
	makeDropdown(IDC_AND_NOT);
	makeDropdown(IDC_OR);
	makeDropdown(IDC_XOR);
	// unary operands
	makeDropdown(IDC_SETALL);
	makeDropdown(IDC_INCREMENT);
	makeDropdown(IDC_DECREMENT);
	makeDropdown(IDC_MINUS);

	makeDropdown(IDC_SHR);
	makeDropdown(IDC_SHL);
	makeDropdown(IDC_UP);
	makeDropdown(IDC_DOWN);

	// Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBinary.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolUnary.EnableDocking(CBRS_ALIGN_ANY);

	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	DockControlBar(&m_wndToolUnary);
	DockControlBar(&m_wndToolBinary);

	m_mapping_mode = (e_mappingmodes) (theApp.GetProfileInt( "Mapping", "mode", e_lerf) & 7);

	return 0;
}


void CMainFrame::OnDestroy() 
{
	theApp.WriteProfileInt("Mapping", "mode", m_mapping_mode);
}


void CMainFrame::UpdateAllViews()
{
	CWinApp *pApp = AfxGetApp();
	CDocManager *pDocMgr = pApp->m_pDocManager;
	for(POSITION TmplPos = pDocMgr->GetFirstDocTemplatePosition(); TmplPos;)
	{
		CDocTemplate *pTmpl = pDocMgr->GetNextDocTemplate(TmplPos);
		if ( pTmpl )
		{
			for(POSITION DocPos = pTmpl->GetFirstDocPosition(); DocPos; ) 
			{
				CDocument *pDoc  = pTmpl->GetNextDoc( DocPos );
				POSITION ViewPos = pDoc->GetFirstViewPosition();
				while( ViewPos )
				{
					CView *pView =  pDoc->GetNextView( ViewPos );
					pView->Invalidate();
				}
			}
		}
	}
}

void CMainFrame::OnLERF()
{
	m_mapping_mode = e_lerf;
	UpdateAllViews();
}

void CMainFrame::OnBERF()
{
	m_mapping_mode = e_berf;
	UpdateAllViews();
}

void CMainFrame::OnLEFR()
{
	m_mapping_mode = e_lefr;
	UpdateAllViews();
}

void CMainFrame::OnBEFR()
{
	m_mapping_mode = e_befr;
	UpdateAllViews();
}


void CMainFrame::OnLERBEF()
{
	m_mapping_mode = e_lerbef;
	UpdateAllViews();
}

void CMainFrame::OnBERLEF()
{
	m_mapping_mode = e_berlef;
	UpdateAllViews();
}

void CMainFrame::OnLEFBER()
{
	m_mapping_mode = e_lefber;
	UpdateAllViews();
}

void CMainFrame::OnBEFLER()
{
	m_mapping_mode = e_befler;
	UpdateAllViews();
}


void CMainFrame::OnUpdateLERF(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_mapping_mode == e_lerf);
}

void CMainFrame::OnUpdateBERF(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_mapping_mode == e_berf);
}

void CMainFrame::OnUpdateLEFR(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_mapping_mode == e_lefr);
}

void CMainFrame::OnUpdateBEFR(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_mapping_mode == e_befr);
}


void CMainFrame::OnUpdateLERBEF(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_mapping_mode == e_lerbef);
}

void CMainFrame::OnUpdateBERLEF(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_mapping_mode == e_berlef);
}

void CMainFrame::OnUpdateLEFBER(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_mapping_mode == e_lefber);
}

void CMainFrame::OnUpdateBEFLER(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_mapping_mode == e_befler);
}



int CMainFrame::squareFromMode( int sq ) const {
	switch ( m_mapping_mode )
	{
	case e_lerf: break;
	case e_berf: sq ^= 63; break;
	case e_lefr: sq = ((sq >> 3) | (sq << 3)) & 63; break;
	case e_befr: sq = (((sq >> 3) | (sq << 3)) & 63) ^ 63; break;
	case e_lerbef: sq ^=  7; break;
	case e_berlef: sq ^= 56; break;
	case e_lefber: sq = (((sq >> 3) | (sq << 3)) & 63) ^  7; break;
	case e_befler: sq = (((sq >> 3) | (sq << 3)) & 63) ^ 56; break;
	
	}
	return sq;
}


void CMainFrame::makeDropdown(u32 cmd) {
	int iButton = m_wndToolBinary.SendMessage(TB_COMMANDTOINDEX, cmd);
	if ( iButton >= 0 ) {
		DWORD dwStyle = m_wndToolBinary.GetButtonStyle(iButton);
		m_wndToolBinary.SetButtonStyle(iButton, dwStyle | TBSTYLE_DROPDOWN);
	}
	iButton = m_wndToolUnary.SendMessage(TB_COMMANDTOINDEX, cmd);
	if ( iButton >= 0 ) {
		DWORD dwStyle = m_wndToolUnary.GetButtonStyle(iButton);
		m_wndToolUnary.SetButtonStyle(iButton, dwStyle | TBSTYLE_DROPDOWN);
	}
}


BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

// diagnostics
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

BOOL CMainFrame::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	return CMDIFrameWnd::OnNotify(wParam, lParam, pResult);
}

void CMainFrame::OnChooseConstant() 
{
	CRect rc;
	CMenu menu;
	menu.LoadMenu(IDR_CONSTANTS);
	CMenu* pPopup = menu.GetSubMenu(0);
	ASSERT(pPopup);
	m_wndToolUnary.SendMessage(TB_GETRECT, IDC_SETALL, (LPARAM)&rc);
	m_wndToolUnary.ClientToScreen(&rc);
	pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_VERTICAL,
							rc.left, rc.bottom, this, &rc);
}
