#include "stdafx.h"
#include "bbstuff.h"
#include "bibobApp.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "bibobDoc.h"
#include "bibobView.h"
#include "About.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CBibobApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(IDC_CLOSE_ALL, OnCloseAll)
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

CBibobApp::CBibobApp()
{
}

CBibobApp theApp; // The one and only CBibobApp object


void CBibobApp::initFont()
{
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	lf.lfHeight = 16;					// request a 16-pixel-height font
	lf.lfQuality = PROOF_QUALITY;
	lf.lfPitchAndFamily = FIXED_PITCH;

	strcpy(lf.lfFaceName, "Tahoma");
//	strcpy(lf.lfFaceName, "Arial Narrow"); // request a face name "Arial"
//	strcpy(lf.lfFaceName, "Courier New"); // request a face name "Courier New"
	VERIFY(m_Font.CreateFontIndirect(&lf));  // create the font
}


BOOL CBibobApp::InitInstance()
{
	initFont();

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	SetRegistryKey(_T("Bibob"));
	LoadStdProfileSettings(); 

	// Register the application's document templates.
	m_pDocTemplate = new CMultiDocTemplate(
		IDR_BIBOBTYPE,
		RUNTIME_CLASS(CBibobDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CBibobView));
	AddDocTemplate(m_pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	return TRUE;
}

int CBibobApp::ExitInstance() 
{
	m_Font.DeleteObject();
	return CWinApp::ExitInstance();
}

void CBibobApp::enumerateBBDocs(CComboBox &combo)
{
	CString bbstr, item;
	CBibobDoc* pdoc;

	POSITION pos = m_pDocTemplate->GetFirstDocPosition();
	while ( pos )
	{
		pdoc = (CBibobDoc*)m_pDocTemplate->GetNextDoc(pos);
		u64 bb = pdoc->getBitBoard();
		if ( bb ) {
			bb2hexStr(bb, bbstr);
			item = pdoc->appendTitle(bbstr);
			if ( combo.FindStringExact(-1, item) < 0 )
				combo.InsertString(1, item);
		}
	}
}

// App command to run the dialog
void CBibobApp::OnAppAbout() {
	CAbout aboutDlg;
	aboutDlg.DoModal();
}

void CBibobApp::OnCloseAll() {
	m_pDocTemplate->CloseAllDocuments(false);
}

