// bibobDoc.cpp : implementation of the CBibobDoc class
//

#include "stdafx.h"
#include "bbstuff.h"
#include "resource.h"       // main symbols
#include "bibobDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CBibobDoc, CDocument)

BEGIN_MESSAGE_MAP(CBibobDoc, CDocument)
	ON_COMMAND(IDC_STOP_AUTO, OnAutoStop)
END_MESSAGE_MAP()

CBibobDoc::CBibobDoc()
{
	m_BitBoard = 0; 
}

CBibobDoc::~CBibobDoc()
{
}

BOOL CBibobDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	return TRUE;
}

void CBibobDoc::Serialize(CArchive& ar)
{
}

// CBibobDoc diagnostics
#ifdef _DEBUG
void CBibobDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBibobDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

void CBibobDoc::getBitBoardAsHexString(CString &hex) const
{
	bb2hexStr(m_BitBoard, hex);
}

void CBibobDoc::getBitBoardAsBoardString(CString &str) const
{
	bb2BoardStr(m_BitBoard, str);
}

void CBibobDoc::getBitBoardAsDecString(CString &dec) const
{
	bb2decStr(m_BitBoard, dec);
}

bool CBibobDoc::setBitBoardByHexDecFen(const CString &str, u32 piecemask, int calcmode)
{
	int kind = 0;
	m_BitBoard = hexdecfenBB(str, piecemask, calcmode, kind);
	if ( kind == IS_FEN ) {
		m_fen = str;
		return true;
	}
	return false;
}

void CBibobDoc::pasteInternalFen(u32 piecemask, int calcmode)
{
	setBitBoardByHexDecFen(m_fen, piecemask, calcmode);
	UpdateAllViews(NULL);
}

void CBibobDoc::clearFen()
{
	m_fen = "";
}

CString CBibobDoc::getDocTitle() {
	CString hex;
	getBitBoardAsHexString(hex);
	return appendTitle(hex);
}

CString CBibobDoc::appendTitle(const CString& s) {
	return s + _T(" - ") + GetTitle();
}

void CBibobDoc::StopAuto() {
	POSITION pos = GetFirstViewPosition();
	while ( pos ) {
		CView* pview = GetNextView(pos);
		pview->SendMessage(WM_COMMAND, IDC_STOP);
	}
}

void CBibobDoc::OnAutoStop() 
{
	StopAuto();
}
