// bbviewView.cpp : implementation of the CBibobView class
//

#include "stdafx.h"
#include "bbstuff.h"
#include "bibobApp.h"

#include "ChildFrm.h"
#include "MainFrm.h"
#include "bibobDoc.h"
#include "bibobView.h"
#include <afxadv.h>
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

COLORREF CBibobView::m_sSquareColors[2] = {
	RGB(127,127,127),
	RGB(196,196,196)
};

bool CBibobView::m_sHasFen = false;
bool CBibobView::m_sSomething2Paste = false;


IMPLEMENT_DYNCREATE(CBibobView, CView)

BEGIN_MESSAGE_MAP(CBibobView, CView)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(IDC_CLEAR, OnClear)
	ON_COMMAND(IDC_SETALL, OnSetall)
	ON_COMMAND(IDC_DECREMENT, OnDecrement)
	ON_COMMAND(IDC_INCREMENT, OnIncrement)
	ON_COMMAND(IDC_INVERT, OnInvert)
	ON_COMMAND(IDC_MINUS, OnMinus)
	ON_COMMAND(IDC_SHL, OnShl)
	ON_COMMAND(IDC_SHR, OnShr)
	ON_COMMAND(IDC_DOWN, OnDown)
	ON_COMMAND(IDC_UP, OnUp)
	ON_COMMAND(IDC_ASSIGN1, OnAssign)
	ON_COMMAND(IDC_ADD1, OnAdd)
	ON_COMMAND(IDC_SUB1, OnSub)
	ON_COMMAND(IDC_MUL1, OnMul)
	ON_COMMAND(IDC_MULH1, OnMulh)
	ON_COMMAND(IDC_DIV1, OnDiv)
	ON_COMMAND(IDC_MODULUS1, OnModulus)
	ON_COMMAND(IDC_AND1, OnAnd)
	ON_COMMAND(IDC_OR1, OnOr)
	ON_COMMAND(IDC_XOR1, OnXor)
	ON_COMMAND(IDC_ALL_FEN, OnAllFen)
	ON_UPDATE_COMMAND_UI(IDC_ALL_FEN, OnUpdateAllFen)
	ON_COMMAND(IDC_BLACK_FEN, OnBlackFen)
	ON_UPDATE_COMMAND_UI(IDC_BLACK_FEN, OnUpdateBlackFen)
	ON_COMMAND(IDC_WHITE_FEN, OnWhiteFen)
	ON_UPDATE_COMMAND_UI(IDC_WHITE_FEN, OnUpdateWhiteFen)
	ON_COMMAND(IDC_KING, OnKing)
	ON_UPDATE_COMMAND_UI(IDC_KING, OnUpdateKing)
	ON_COMMAND(IDC_KNIGHT, OnKnight)
	ON_UPDATE_COMMAND_UI(IDC_KNIGHT, OnUpdateKnight)
	ON_COMMAND(IDC_PAWN, OnPawn)
	ON_COMMAND(IDC_QUEEN, OnQueen)
	ON_UPDATE_COMMAND_UI(IDC_QUEEN, OnUpdateQueen)
	ON_UPDATE_COMMAND_UI(IDC_PAWN, OnUpdatePawn)
	ON_COMMAND(IDC_ROOK, OnRook)
	ON_UPDATE_COMMAND_UI(IDC_ROOK, OnUpdateRook)
	ON_COMMAND(IDC_BISHOP, OnBishop)
	ON_UPDATE_COMMAND_UI(IDC_BISHOP, OnUpdateBishop)
	ON_COMMAND(IDC_FEN_NO_PIECES, OnFenNoPieces)
	ON_UPDATE_COMMAND_UI(IDC_FEN_NO_PIECES, OnUpdateFenNoPieces)
	ON_WM_CHAR()
	ON_COMMAND(IDC_FEN_CHOOSED, OnFenChoosed)
	ON_COMMAND(IDC_AND_NOT1, OnAndNot)
	ON_COMMAND(IDC_INT2FLOAT, OnInt2float)
	ON_COMMAND(IDC_FLOAT2INT, OnFloat2int)
	ON_COMMAND(IDC_1_DIV_N, On1DivN)
	ON_COMMAND(IDC_FLIP, OnFlip)
	ON_COMMAND(IDC_MIRROR, OnMirror)
	ON_COMMAND(IDC_DIAFLIP, OnDiaFlip)
	ON_COMMAND(IDC_ANTFLIP, OnAntFlip)
	ON_COMMAND(IDC_REVERSE, OnReverse)
	ON_COMMAND(IDC_ADD_TO_COMBO, OnAddToCombo)
	ON_UPDATE_COMMAND_UI(IDC_ADD_TO_COMBO, OnUpdateAddToCombo)
	ON_COMMAND(IDC_ADD_FLOAT_TO_COMBO, OnAddFloatToCombo)
	ON_UPDATE_COMMAND_UI(IDC_ADD_FLOAT_TO_COMBO, OnUpdateAddFloatToCombo)
	ON_COMMAND(IDC_STOP, OnStop)
	ON_COMMAND(IDC_E, OnE)
	ON_COMMAND(IDC_PI, OnPi)
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

CBibobView::CBibobView()
{
	m_CurrentSquare = 0;
	m_fenOption = all;
	m_pmask = -1;
}

CBibobView::~CBibobView() {}

// CBibobView rects and squares
void CBibobView::GetRect4Board(CRect &rect) const {
	GetClientRect(rect);
	if (rect.Width() > rect.Height())
		rect.right = rect.bottom;
	else
		rect.bottom = rect.right;
}

void CBibobView::getBoardRect(CRect &rect) const {
	GetRect4Board(rect);
	rect.DeflateRect(8, 16+2, 8, 16+2); // boarder
}

void CBibobView::getTextRect(CRect &rect) const {
	GetClientRect(rect);
	rect.bottom = rect.top + 16 + 2;
	rect.left += 6;	
}

void CBibobView::getTextRect1(CRect &rect) const {
	CRect crect;
	GetClientRect(crect);
	getBoardRect(rect);
	rect.left = rect.right + 4;
	rect.right = crect.right;
}

void CBibobView::getFenRect(CRect &rect) const {
	CRect crect;
	GetClientRect(crect);
	getBoardRect(rect);
	rect.top = rect.bottom;
	rect.bottom = crect.bottom;
	rect.right = crect.right;
}


void CBibobView::getSquareRect(int sq, CRect &rect) const {
	CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
	if ( pFrame )
		sq = pFrame->squareFromMode ( sq );
	getBoardRect(rect);
	int w = rect.Width()  / 8;
	int h = rect.Height() / 8;
	int l = rect.left;
	int t = rect.top;
	int file = sq & 7;
	int rank = (sq >> 3) ^ 7;
	rect.SetRect(l+file*w,t+rank*h, l+file*w+w, t+rank*h+h);
}

int CBibobView::findSquareByPoint(CPoint point)  const {
	CRect rect; 
	for (int sq=0; sq < 64; sq++) {
		getSquareRect(sq, rect);
		if (rect.PtInRect(point))
			return sq;
	}
	return -1;
}

int CBibobView::getLineHeight() const {
	CRect rect;
	GetRect4Board(rect);
	return rect.Height()/23;
}

CFont* CBibobView::selectFont(CDC* pDC)
{
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));	// zero out structure

	lf.lfHeight = getLineHeight();
	lf.lfQuality = PROOF_QUALITY;
	lf.lfWeight  = 300 + 10*getLineHeight();
	lf.lfPitchAndFamily = FIXED_PITCH;

	strcpy(lf.lfFaceName, "Courier New"); // request a face name "Courier New"
	VERIFY(m_Font.CreateFontIndirect(&lf));  // create the font
	CFont* pfont = pDC->SelectObject(&m_Font);
	return pfont;
}

// CBibobView drawing
void CBibobView::squareUpdate(int sq) {
	sq &= 63;
	if (sq != m_CurrentSquare) {
		invalidateSquare(m_CurrentSquare);
		invalidateSquare(m_CurrentSquare = sq);
	}
}


void CBibobView::invalidateSquare(int sq) {
	CRect rect; 
	getSquareRect(sq, rect);
	InvalidateRect(rect);
}

void CBibobView::invalidateText() {
	CRect rect; 
	getTextRect(rect);
	InvalidateRect(rect);
	getTextRect1(rect);
	InvalidateRect(rect);
	getFenRect(rect);
	InvalidateRect(rect);
}

void CBibobView::invalidate(u64 changed) {
	if ( changed ) {
		invalidateText();
		for (int sq=0; sq < 64; sq++, changed >>= 1) {
			if ( changed & 1 )
				invalidateSquare(sq);
		}
	}
}

void CBibobView::drawSquare(CDC* pDC, int sq, bool isone) {
	CRect rect; 
	getSquareRect(sq, rect);
	int rank = sq >> 3;
	int file = sq & 7;
	int sqtype = (sq^rank)&1;
	int calcmode = getFrame()->calcMode();
	pDC->FillSolidRect(rect, m_sSquareColors[sqtype]);
	CString sqStr;
	CBrush brush;
	COLORREF rgb;
	int h = rect.Height() / 16;
	rect.DeflateRect(h,h);
	int rlsq = sq;
	if (sq==63 && calcmode == DBL ) {
		rgb = RGB(255,0,0);
		sqStr.Format("-");
	} else if (sq==62 && calcmode == DBL) {
		rgb = RGB(255,13,128);
		sqStr.Format("%d", sq-52);
	} else if (sq>=52 && calcmode == DBL) {
		sqStr.Format("%d", sq-52);
		rgb = RGB(rank*31,255-sq*2,file*31);
	} else {
		if ( calcmode == DBL ) {
			sqStr.Format("-%d", 52-sq);
		} else {
			if ( calcmode == I32 ) {
				rank &= 3;
				rank *= 2;
				rlsq &= 31;
			} else 	if ( calcmode == I16 ) {
				rank &= 1;
				rank *= 6;
				rlsq &= 15;
			} else 	if ( calcmode == I8 ) {
				rank = 0;
				rlsq &= 7;
			}
			sqStr.Format("%d", rlsq);
		}
		//rgb = RGB(file*32^255,(7-file+rank/3)*15^255, rank*31^11);
		//rgb = RGB((7-file+rank/3)*15^255, file*32^255, rank*31^11);
		rgb = RGB(rank*23^255, (7-file+rank/3)*15^255, file*32^255 );
	}
	if (isone) {
		brush.CreateSolidBrush(rgb);
		CBrush *poldbrush = pDC->SelectObject(&brush);
		pDC->Ellipse(rect);
		pDC->SelectObject(poldbrush);
	}

	rect.InflateRect(1,0);
	if (sq == m_CurrentSquare)
		pDC->DrawFocusRect(rect);

	if (isone) {
		pDC->SetTextAlign(TA_CENTER);
		int bkmode = pDC->SetBkMode(TRANSPARENT);
		CPoint p = rect.CenterPoint();
		p.y -= rect.Height()/5;
		pDC->TextOut(p.x, p.y, sqStr);
		pDC->SetBkMode(bkmode);
		pDC->SetTextAlign(TA_LEFT);
	}
}

void CBibobView::drawBitBoard(CDC* pDC, u64 bb) {
	CFont* pfont = selectFont(pDC);
	for (int sq=0; sq<64; sq++, bb>>=1) {
		drawSquare(pDC, sq, (int)bb & 1);
	}
	pDC->SelectObject(pfont);
	m_Font.DeleteObject();
}

void CBibobView::drawBitBoardAsString(CDC* pDC, u64 bb) {
	CString hexstr, decstr, pcstr, dblstr, fen;
	CRect rect; 
	union64 dbl;

	dbl.bb = bb;

	getTextRect(rect);
	pDC->SetBkColor(RGB(255,255,255));
	CFont* pfont = pDC->SelectObject(theApp.getFont());

	bb2hexStr(bb, hexstr);
	dblstr.Format(" asDouble: %.20g ", dbl.dbl);
	pcstr.Format("  oneBits: %2d", popCount(bb));
	pDC->TextOut(rect.left, rect.top, hexstr + pcstr + dblstr);

	getTextRect1(rect);
	int h = rect.Height();
	int calcmode = getFrame()->calcMode();

	switch( calcmode ) {
	case I64:
		bb2decStr(bb, decstr);
		pDC->TextOut(rect.left, rect.top, decstr);
		break;
	case I32:
		rect.top += h/4 - 8;
		decstr.Format("%10d", (int)(bb>>32));
		pDC->TextOut(rect.left, rect.top, decstr);
		decstr.Format("%10d", (int)bb);
		pDC->TextOut(rect.left, rect.top + h/2, decstr);
		break;
	case I16:
		rect.top += h/8 - 6;
		decstr.Format("%6d", (short)(bb>>48));
		pDC->TextOut(rect.left, rect.top, decstr);
		decstr.Format("%6d", (short)((bb>>32) & 0xffff));
		pDC->TextOut(rect.left, rect.top + h/4, decstr);
		decstr.Format("%6d", (short)((bb>>16) & 0xffff));
		pDC->TextOut(rect.left, rect.top + 2*h/4, decstr);
		decstr.Format("%6d", (short)((bb) & 0xffff));
		pDC->TextOut(rect.left, rect.top + 3*h/4, decstr);
		break;
	case I8:
		rect.top += h/16 - 6;
		decstr.Format("%4d", (char)(bb>>56));
		pDC->TextOut(rect.left, rect.top, decstr);
		decstr.Format("%4d", (char)((bb>>48) & 0xff));
		pDC->TextOut(rect.left, rect.top + h/8, decstr);
		decstr.Format("%4d", (char)((bb>>40) & 0xff));
		pDC->TextOut(rect.left, rect.top + 2*h/8, decstr);
		decstr.Format("%4d", (char)((bb>>32) & 0xff));
		pDC->TextOut(rect.left, rect.top + 3*h/8, decstr);
		decstr.Format("%4d", (char)((bb>>24) & 0xff));
		pDC->TextOut(rect.left, rect.top + 4*h/8, decstr);
		decstr.Format("%4d", (char)((bb>>16) & 0xff));
		pDC->TextOut(rect.left, rect.top + 5*h/8, decstr);
		decstr.Format("%4d", (char)((bb>>8) & 0xff));
		pDC->TextOut(rect.left, rect.top + 6*h/8, decstr);
		decstr.Format("%4d", (char)((bb) & 0xff));
		pDC->TextOut(rect.left, rect.top + 7*h/8, decstr);
		break;
	case DBL:
		break;
	}
	
	if ( hasFenInternal() ) {
		getFenRect(rect);
		fen.Format("Fen: %s", getFen());
		pDC->TextOut(rect.left, rect.top, fen);
	}
	pDC->SelectObject(pfont);
}

void CBibobView::OnDraw(CDC* pDC) {
	CBibobDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	drawBitBoardAsString(pDC, pDoc->getBitBoard());
	drawBitBoard(pDC, pDoc->getBitBoard());
}

// CBibobView printing
BOOL CBibobView::OnPreparePrinting(CPrintInfo* pInfo)
{
	return DoPreparePrinting(pInfo);
}

void CBibobView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CBibobView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

// CBibobView diagnostics
#ifdef _DEBUG
void CBibobView::AssertValid() const
{
	CView::AssertValid();
}

void CBibobView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBibobDoc* CBibobView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBibobDoc)));
	return (CBibobDoc*)m_pDocument;
}
#endif //_DEBUG


CChildFrame* CBibobView::getFrame() const {
	CWnd* pChildFrame = GetParent();
	ASSERT (pChildFrame);
	ASSERT(pChildFrame->IsKindOf(RUNTIME_CLASS(CChildFrame)));
	return (CChildFrame*)pChildFrame;
}

struct CChangeInfo : public CObject {
	CChangeInfo(u64 c) {changed = c;}
	u64 changed;
};

void CBibobView::setBitboard(u64 bb) {
	CBibobDoc* pDoc = GetDocument();
	u64 pre = pDoc->getBitBoard();
	pDoc->setBitBoard(bb);
	invalidate(pre^bb);
	CChangeInfo ci(pre^bb);
	pDoc->UpdateAllViews(this, 0, &ci);
}

void CBibobView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if ( pHint ) {
		CChangeInfo* pc = (CChangeInfo*)pHint;
		invalidate(pc->changed);
	} else
		invalidate(-1);
}

void CBibobView::toggleSquare(int sq) {
	CBibobDoc* pDoc = GetDocument();
	u64 one = 1;
	u64 bb = pDoc->getBitBoard();
	setBitboard( bb ^ (one<<sq));
}

bool CBibobView::hasFenInClipBoard() {
	char buff[256];
	CSharedFile mf;
	bool isfen = false;
	if ( OpenClipboard() ) {
		HGLOBAL hMem = ::GetClipboardData(CF_TEXT);
		if ( hMem )	{
			mf.SetHandle(hMem);
			int n = mf.Read(buff, sizeof(buff)-1);
			mf.Detach();
			buff[sizeof(buff)-1] = '\0';
			if ( n > 0 ) isfen = isFen(CString(buff));
		}
		CloseClipboard();
	}
	return isfen;
}

bool CBibobView::something2paste() {
	bool has = false;
	if ( OpenClipboard() ) {
		has = GetClipboardData(CF_TEXT) != NULL;
		CloseClipboard();
	}
	return has;
}

void CBibobView::paste(u32 piecemask) {
	char buff[8192];
	CSharedFile mf;
	int n = 0;
	CBibobDoc* pDoc = GetDocument();
	OpenClipboard();
	HGLOBAL hMem = ::GetClipboardData(CF_TEXT);
	if ( hMem ) {
		mf.SetHandle(hMem);
		n = mf.Read(buff, sizeof(buff)-1);
		buff[sizeof(buff)-1] = '\0';
		mf.Detach();
	}
	CloseClipboard();
	if ( n > 0 ) {
		for (n--; n > 0; n-- ) {
			if (strchr("\n\r\t ", buff[n] ) == NULL )
				break;
			buff[n] = '\0'; // trim right
		}
		CString str(buff);
		int calcmode = getFrame()->calcMode();
		if ( pDoc->setBitBoardByHexDecFen(str, piecemask, calcmode) ) // true if fen
			getFrame()->insert2FenCombo(str);
		pDoc->UpdateAllViews(NULL);
	}
}

void CBibobView::pasteFen(u32 piecemask) {
	if ( hasFenInternal() ) {
		int calcmode = getFrame()->calcMode();
		GetDocument()->pasteInternalFen(piecemask, calcmode);
	} else if ( m_sHasFen ) {
		paste(piecemask);
	}
}

void CBibobView::OnFenChoosed() 
{
	CBibobDoc* pDoc = GetDocument();
	const CString& fen = getFrame()->getChoosedFen();
	if ( !isFen(fen) ) {
		pDoc->clearFen();
		invalidateText();
		pDoc->UpdateAllViews(this);
	} else if ( m_fenOption == none ) {
		m_fenOption = all;
		m_pmask = -1;
		int calcmode = getFrame()->calcMode();
		pDoc->setBitBoardByHexDecFen(fen, fenOptionMask(), calcmode);
		m_fenOption = none;
		m_pmask = 0;
		OnInvert();
	} else {
		int calcmode = getFrame()->calcMode();
		pDoc->setBitBoardByHexDecFen(fen, fenOptionMask(), calcmode);
		pDoc->UpdateAllViews(NULL);
	}
}
	
// CBibobView message handlers (controller)
void CBibobView::OnEditCopy() 
{
	CString hex;
	CBibobDoc* pDoc = GetDocument();
	pDoc->getBitBoardAsHexString(hex);
	CSharedFile mf(GMEM_MOVEABLE|GMEM_DDESHARE|GMEM_ZEROINIT);
	mf.Write(hex.GetBuffer(16), hex.GetLength() + 1);
	HGLOBAL hMem = mf.Detach();
	if ( hMem && OpenClipboard() ) {
		EmptyClipboard();
		SetClipboardData(CF_TEXT, hMem);
		CloseClipboard();
		m_sHasFen = false; // is hex
		m_sSomething2Paste = true;
	}
	hex.ReleaseBuffer();
}

void CBibobView::OnEditCut() 
{
	m_fenOption = all;
	m_pmask = -1;
	paste(-1);
	setBitboard(0);
}

void CBibobView::OnEditPaste() {
	m_fenOption = all;
	m_pmask = -1;
	paste(-1);
} 


u32 CBibobView::fenOptionMask() const {
	if ( m_fenOption == white )	return 0x5555 & m_pmask;
	if ( m_fenOption == black )	return 0xaaaa & m_pmask;
	return m_pmask;
}

// Fen Paste
void CBibobView::OnAllFen()
{
	if ( m_pmask == 0 )
		m_pmask = -1;
	m_fenOption = all;
	pasteFen(fenOptionMask());
}

void CBibobView::OnWhiteFen() {
	if ( m_pmask == 0 )
		m_pmask = -1;
	m_fenOption = white;
	pasteFen(fenOptionMask());
}

void CBibobView::OnBlackFen() {
	if ( m_pmask == 0 )
		m_pmask = -1;
	m_fenOption = black;
	pasteFen(fenOptionMask());
}

void CBibobView::OnKing() {
	if ( m_fenOption == none )
		m_fenOption = all;
	m_pmask ^= 0x000c; 
	pasteFen(fenOptionMask());
}

void CBibobView::OnPawn() {
	if ( m_fenOption == none )
		m_fenOption = all;
	m_pmask ^= 0x0030;
	pasteFen(fenOptionMask());
}

void CBibobView::OnKnight() {
	if ( m_fenOption == none )
		m_fenOption = all;
	m_pmask ^= 0x00c0;
	pasteFen(fenOptionMask());
}

void CBibobView::OnBishop() {
	if ( m_fenOption == none )
		m_fenOption = all;
	m_pmask ^= 0x0300;
	pasteFen(fenOptionMask());
}

void CBibobView::OnRook() {
	if ( m_fenOption == none )
		m_fenOption = all;
	m_pmask ^= 0x0c00; 
	pasteFen(fenOptionMask());
}

void CBibobView::OnQueen()
{
	if ( m_fenOption == none )
		m_fenOption = all;
	m_pmask ^= 0x3000; 
	pasteFen(fenOptionMask());
}

void CBibobView::OnFenNoPieces() 
{
	m_fenOption = none;
	m_pmask = -1;
	pasteFen(fenOptionMask());
	m_pmask = 0;
	OnInvert();
}

bool CBibobView::hasFen() {return ( m_sHasFen || hasFenInternal() );}
void CBibobView::OnUpdateEditPaste(CCmdUI* pc) {pc->Enable(m_sSomething2Paste);}
void CBibobView::OnUpdateAllFen  (CCmdUI* pc)  {pc->Enable(hasFen()); pc->SetCheck(m_fenOption == all);}
void CBibobView::OnUpdateWhiteFen(CCmdUI* pc)  {pc->Enable(hasFen()); pc->SetCheck(m_fenOption == white);}
void CBibobView::OnUpdateBlackFen(CCmdUI* pc)  {pc->Enable(hasFen()); pc->SetCheck(m_fenOption == black);}

void CBibobView::OnUpdateKing(CCmdUI* pc)	    {pc->Enable(hasFen()); pc->SetCheck(!!(m_pmask & 0x000c));}
void CBibobView::OnUpdatePawn(CCmdUI* pc)	    {pc->Enable(hasFen()); pc->SetCheck(!!(m_pmask & 0x0030));}
void CBibobView::OnUpdateKnight(CCmdUI* pc)    {pc->Enable(hasFen()); pc->SetCheck(!!(m_pmask & 0x00c0));}
void CBibobView::OnUpdateBishop(CCmdUI* pc)    {pc->Enable(hasFen()); pc->SetCheck(!!(m_pmask & 0x0300));}
void CBibobView::OnUpdateRook(CCmdUI* pc)	    {pc->Enable(hasFen()); pc->SetCheck(!!(m_pmask & 0x0c00));}
void CBibobView::OnUpdateQueen(CCmdUI* pc)     {pc->Enable(hasFen()); pc->SetCheck(!!(m_pmask & 0x3000));}

void CBibobView::OnUpdateFenNoPieces(CCmdUI* pc) {pc->Enable(hasFen()); pc->SetCheck(m_fenOption == none);}


void CBibobView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	m_sHasFen = hasFenInClipBoard();
	m_sSomething2Paste = something2paste();
	CView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}

void CBibobView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CView::OnLButtonDown(nFlags, point);
	GetDocument()->StopAuto();
	int sq = findSquareByPoint(point);
	if ( sq >= 0 )
		squareUpdate(sq);
}

void CBibobView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CView::OnLButtonDblClk(nFlags, point);
	int sq = findSquareByPoint(point);
	if ( sq >= 0 ) 
		toggleSquare(sq);
}

BOOL CBibobView::PreTranslateMessage(MSG* pMsg) 
{
	if ( pMsg->message == WM_KEYDOWN && pMsg->hwnd == this->m_hWnd ) {
		GetDocument()->StopAuto();
		switch ( pMsg->wParam )
		{
		case VK_RETURN:
			getFrame()->PostMessage(WM_COMMAND, IDC_ASSIGN, 0L);
			break;
		case VK_DELETE:
			setBitboard(0);
			break;
		case VK_SPACE:
			toggleSquare(m_CurrentSquare);
			break;
		}
	}
	return CView::PreTranslateMessage(pMsg);
}

void CBibobView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	GetDocument()->StopAuto();
	switch (nChar)
	{
	case VK_DOWN:	squareUpdate(m_CurrentSquare-8);	break;
	case VK_UP:		squareUpdate(m_CurrentSquare+8);	break;
	case VK_LEFT:	squareUpdate(m_CurrentSquare-1);	break;
	case VK_RIGHT:	squareUpdate(m_CurrentSquare+1);	break;
	}
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CBibobView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	GetDocument()->StopAuto();
	if (isdigit(nChar)) {
		getFrame()->PostMessage(WM_COMMAND, IDC_CURRENT_BOARD, 0);
		getFrame()->postChar2Combo(nChar);
		return;
	}
	CView::OnChar(nChar, nRepCnt, nFlags);
}


void CBibobView::OnClear()  {
	GetDocument()->StopAuto();
	setBitboard(0);
}

void CBibobView::OnSetall() {
	GetDocument()->StopAuto();
	setBitboard(-1);
}

// unaries
void CBibobView::OnInvert() {
	setBitboard(~getCurBB());
}

void CBibobView::OnDecrement() {
	union64 ubb;
	ubb.bb = getCurBB();
	switch ( getFrame()->calcMode() ) {
	case DBL: ubb.dbl -= 1.0;								break;
	case I64: ubb.bb--;										break;
	case I32: ubb.bb = sub32(ubb.bb, 0x0000000100000001);	break;
	case I16: ubb.bb = sub16(ubb.bb, 0x0001000100010001);	break;
	case I8:  ubb.bb = sub8(ubb.bb,  0x0101010101010101);	break;
	}
	setBitboard(ubb.bb);
}

void CBibobView::OnIncrement() {
	union64 ubb;
	ubb.bb = getCurBB();
	switch ( getFrame()->calcMode() ) {
	case DBL: ubb.dbl += 1.0;								break;
	case I64: ubb.bb++;										break;
	case I32: ubb.bb = add32(ubb.bb, 0x0000000100000001);	break;
	case I16: ubb.bb = add16(ubb.bb, 0x0001000100010001);	break;
	case I8:  ubb.bb = add8(ubb.bb,  0x0101010101010101);	break;
	}
	setBitboard(ubb.bb);
}

void CBibobView::OnMinus()	{
	union64 ubb;
	ubb.bb = getCurBB();
	switch ( getFrame()->calcMode() ) {
	case DBL: ubb.bb ^= 0x8000000000000000;					break;
	case I64: ubb.bb  = -(i64)ubb.bb;						break;
	case I32: ubb.bb = ~sub32(ubb.bb, 0x0000000100000001);	break;
	case I16: ubb.bb = ~sub16(ubb.bb, 0x0001000100010001);	break;
	case I8:  ubb.bb = ~sub8(ubb.bb,  0x0101010101010101);	break;
	}
	setBitboard(ubb.bb);
}

void CBibobView::OnInt2float() 
{
	union64 ubb;
	ubb.dbl = (double)(i64)getCurBB();
	setBitboard(ubb.bb);
}

void CBibobView::OnFloat2int() 
{
	union64 ubb;
	ubb.bb = getCurBB();
	ubb.bb = (i64)ubb.dbl;
	setBitboard(ubb.bb);
}

// shifts
void CBibobView::OnShl()	{setBitboard(getCurBB()<<1);}
void CBibobView::OnShr()	{setBitboard(getCurBB()>>1);}
void CBibobView::OnDown()	{setBitboard(getCurBB()>>8);}
void CBibobView::OnUp()	{setBitboard(getCurBB()<<8);}

// binaries
void CBibobView::OnAssign(){setBitboard(getSecBB());}

void CBibobView::OnAdd() {
	union64 ubb1;
	union64 ubb2;
	ubb1.bb = getCurBB();
	ubb2.bb = getSecBB();
	switch ( getFrame()->calcMode() ) {
	case DBL: ubb1.dbl += ubb2.dbl;				break;
	case I64: ubb1.bb  += ubb2.bb;				break;
	case I32: ubb1.bb = add32(ubb1.bb,ubb2.bb);	break;
	case I16: ubb1.bb = add16(ubb1.bb,ubb2.bb);	break;
	case I8:  ubb1.bb = add8 (ubb1.bb,ubb2.bb);	break;
	}
	setBitboard(ubb1.bb); 
}

void CBibobView::OnSub() {
	union64 ubb1;
	union64 ubb2;
	ubb1.bb = getCurBB();
	ubb2.bb = getSecBB();
	switch ( getFrame()->calcMode() ) {
	case DBL: ubb1.dbl -= ubb2.dbl;				break;
	case I64: ubb1.bb  -= ubb2.bb;				break;
	case I32: ubb1.bb = sub32(ubb1.bb,ubb2.bb);	break;
	case I16: ubb1.bb = sub16(ubb1.bb,ubb2.bb);	break;
	case I8:  ubb1.bb = sub8 (ubb1.bb,ubb2.bb);	break;
	}
	setBitboard(ubb1.bb); 
}

void CBibobView::OnMul() {
	union64 ubb1;
	union64 ubb2;
	ubb1.bb = getCurBB();
	ubb2.bb = getSecBB();
	int calcmode = getFrame()->calcMode();
	if ( calcmode == DBL ) {
		ubb1.dbl *= ubb2.dbl;
	} else if ( calcmode == I64 ) {
		ubb1.bb  *= ubb2.bb;
	} else if ( calcmode == I32 ) {
		u32 a1 = (u32) ubb1.bb;
		u32 b1 = (u32)(ubb1.bb>>32);
		u32 a2 = (u32) ubb2.bb;
		u32 b2 = (u32)(ubb2.bb>>32);
		a1 *= a2;
		b1 *= b2;
		ubb1.bb  = b1;
		ubb1.bb <<= 32;
		ubb1.bb |= a1;
	} else if ( calcmode == I16 ) {
		u32 a1 = (u32) ubb1.bb;
		u32 b1 = (u32)(ubb1.bb>>16);
		u32 c1 = (u32)(ubb1.bb>>32);
		u32 d1 = (u32)(ubb1.bb>>48);
		u32 a2 = (u32) ubb2.bb;
		u32 b2 = (u32)(ubb2.bb>>16);
		u32 c2 = (u32)(ubb2.bb>>32);
		u32 d2 = (u32)(ubb2.bb>>48);

		a1 &= 0xffff;	b1 &= 0xffff;	c1 &= 0xffff;	d1 &= 0xffff;
		a2 &= 0xffff;	b2 &= 0xffff;	c2 &= 0xffff;	d2 &= 0xffff;
		a1 *= a2;		b1 *= b2;		c1 *= c2;		d1 *= d2;
		a1 &= 0xffff;	b1 &= 0xffff;	c1 &= 0xffff;	d1 &= 0xffff;

		ubb1.bb  = d1;
		ubb1.bb <<= 16;
		ubb1.bb |= c1;
		ubb1.bb <<= 16;
		ubb1.bb |= b1;
		ubb1.bb <<= 16;
		ubb1.bb |= a1;
	} else if ( calcmode == I8 ) {
		u32 a1 = (u32) ubb1.bb;
		u32 b1 = (u32)(ubb1.bb>>8);
		u32 c1 = (u32)(ubb1.bb>>16);
		u32 d1 = (u32)(ubb1.bb>>24);
		u32 e1 = (u32)(ubb1.bb>>32);
		u32 f1 = (u32)(ubb1.bb>>40);
		u32 g1 = (u32)(ubb1.bb>>48);
		u32 h1 = (u32)(ubb1.bb>>56);

		u32 a2 = (u32) ubb2.bb;
		u32 b2 = (u32)(ubb2.bb>>8);
		u32 c2 = (u32)(ubb2.bb>>16);
		u32 d2 = (u32)(ubb2.bb>>24);
		u32 e2 = (u32)(ubb2.bb>>32);
		u32 f2 = (u32)(ubb2.bb>>40);
		u32 g2 = (u32)(ubb2.bb>>48);
		u32 h2 = (u32)(ubb2.bb>>56);

		a1 &= 255;	b1 &= 255;	c1 &= 255;	d1 &= 255;
		e1 &= 255;	f1 &= 255;	g1 &= 255;	h1 &= 255;
		a2 &= 255;	b2 &= 255;	c2 &= 255;	d2 &= 255;
		e2 &= 255;	f2 &= 255;	g2 &= 255;	h2 &= 255;

		a1 *= a2;	b1 *= b2;	c1 *= c2;	d1 *= d2;
		e1 *= e2;	f1 *= f2;	g1 *= g2;	h1 *= h2;
		a1 &= 255;	b1 &= 255;	c1 &= 255;	d1 &= 255;
		e1 &= 255;	f1 &= 255;	g1 &= 255;	h1 &= 255;

		ubb1.bb  = h1;
		ubb1.bb <<= 8;
		ubb1.bb |= g1;
		ubb1.bb <<= 8;
		ubb1.bb |= f1;
		ubb1.bb <<= 8;
		ubb1.bb |= e1;
		ubb1.bb <<= 8;
		ubb1.bb |= d1;
		ubb1.bb <<= 8;
		ubb1.bb |= c1;
		ubb1.bb <<= 8;
		ubb1.bb |= b1;
		ubb1.bb <<= 8;
		ubb1.bb |= a1;
	}
	setBitboard(ubb1.bb); 
}

void CBibobView::OnDiv()   {
	union64 ubb1;
	union64 ubb2;
	ubb1.bb = getCurBB();
	ubb2.bb = getSecBB();
	int calcmode = getFrame()->calcMode();
	if ( calcmode == DBL ) {
		ubb1.dbl /= ubb2.dbl;
		setBitboard(ubb1.bb); 
	} else 	if (ubb2.bb) {
		ubb1.bb  /= ubb2.bb;
		setBitboard(ubb1.bb); 
	} else { // division by zero
		MessageBeep(-1);
	}
}

void CBibobView::OnModulus() 
{
	union64 ubb1;
	union64 ubb2;
	ubb1.bb = getCurBB();
	ubb2.bb = getSecBB();
	int calcmode = getFrame()->calcMode();
	if ( calcmode == DBL ) {
		ubb1.dbl = fmod(ubb1.dbl,ubb2.dbl);
		setBitboard(ubb1.bb); 
	} else 	if (ubb2.bb) {
		ubb1.bb  %= ubb2.bb;
		setBitboard(ubb1.bb); 
	} else { // division by zero
		MessageBeep(-1);
	}
}


void CBibobView::OnMulh()
{
	setBitboard(mulh(getCurBB(), getSecBB()));
}

void CBibobView::OnAnd()
{
	setBitboard(getCurBB() & getSecBB());
}

void CBibobView::OnAndNot()
{
	setBitboard(getCurBB() &~getSecBB());
} 

void CBibobView::OnOr()	
{
	setBitboard(getCurBB() | getSecBB());
}

void CBibobView::OnXor()
{
	setBitboard(getCurBB() ^ getSecBB());
}


void CBibobView::On1DivN() 
{
	union64 ubb1;
	ubb1.bb  = getCurBB();
	ubb1.dbl = 1/ubb1.dbl;
	setBitboard(ubb1.bb); 
}


void CBibobView::OnFlip()
{
	setBitboard( flip( getCurBB() ) );
}

void CBibobView::OnMirror()
{
	setBitboard( mirror(getCurBB()) );
}

void CBibobView::OnDiaFlip()
{
	setBitboard( diaflip(getCurBB()) );
}

void CBibobView::OnAntFlip()
{
	setBitboard( antflip(getCurBB()) );
}

void CBibobView::OnReverse()
{
	setBitboard( flip ( mirror(getCurBB() ) ) );
}



void CBibobView::OnE() 
{
	union64 ubb1;
	ubb1.dbl = exp(1.0);
	setBitboard(ubb1.bb); 
}

void CBibobView::OnPi() 
{
	union64 ubb1;
	ubb1.dbl = 4.0*atan(1.0);
	setBitboard(ubb1.bb); 
}

void CBibobView::OnAddToCombo() 
{
	if ( getCurBB() != 0) // no zero boards
		getFrame()->insert2combo(GetDocument()->getDocTitle());
}

void CBibobView::OnUpdateAddToCombo(CCmdUI* pc) 
{
	pc->Enable(getCurBB() != 0);
}


void CBibobView::OnAddFloatToCombo() 
{
	union64 dbl;
	dbl.bb = getCurBB();
	if ( dbl.bb != 0 ) {// no zero boards
		CString dblstr;
		dblstr.Format("%1.20g", dbl.dbl);
		getFrame()->insert2combo(dblstr);
	}
}

void CBibobView::OnUpdateAddFloatToCombo(CCmdUI* pc) 
{
	pc->Enable(getCurBB() != 0);
}

void CBibobView::OnStop() 
{
	getFrame()->stopAuto();
}



